/*
 * aufgabe1.c
 *
 *  Created on: 17.11.2012
 *      Author: Johann
 */

#include <stdio.h>
#include <math.h>

//Funktionsdeklaration
double f(double);
double df(double);
double newton(double, double, int );

// Hauptprogramm
int main(void){
	setvbuf(stdout, NULL, _IONBF, 0);    /*    Die Standard-Ausgabe wird nicht gepuffert      */

	int Nmax;
	double eps, alpha_0, alpha, h, r=0.75;

	printf("Bitte geben Sie die maximale Anzahl der Iterationen Max_counter ein:");
	scanf("%d", &Nmax);

	printf("Bitte geben Sie die Genauigkeit der Approximation ein:");
	scanf("%lf", &eps);


	printf("Bitte geben Sie den Startwert x_0 ein:");
	scanf("%lf",&alpha_0);

	alpha = newton(alpha_0,eps,Nmax);

	printf("\nDie gesuchte Nullstelle liegt bei %lf\n",alpha);

	h = (r*sin(alpha))/(2*sin(0.5*alpha))+r;

	printf("\nDie Fuellhoehe muesste %.2lf m betragen.\n",h);

	return 0;
}


//Funktionsdefinition

//Funktion f
double f(double alpha)
{
	return alpha-sin(alpha)-2.0/3.0*M_PI;
}

//Ableitung der Funktion f
double df(double alpha)
{
	return  1-cos(alpha);
}

//Newton-Verfahren
double newton(double alpha_0, double eps, int Nmax)
{
	int counter = 0;
	double diff = 1.0, alpha_alt = alpha_0, alpha_neu;
	while(diff >= eps && counter <= Nmax)
	{
		alpha_neu = alpha_alt - f(alpha_alt)/df(alpha_alt);
		diff = fabs(alpha_neu-alpha_alt);
		alpha_alt = alpha_neu;
		counter++;
		printf("n = %d, alpha= %lf\n",counter, alpha_neu);
	}

	printf("\nAnzahl der Schleifendurchlaeufe: %d\n",counter);
	return alpha_neu;
}
