/*
 * aufgabe2.c
 *
 *  Created on: 17.11.2012
 *      Author: Johann
 */

#include <stdio.h>
#include <math.h>

// Funktionsdeklaration
double Rechteck(double, double, int);

// Hauptprogramm
int main(void){
	setvbuf(stdout, NULL, _IONBF, 0);    /*    Die Standard-Ausgabe wird nicht gepuffert      */

	double a, b, integral, int_exakt,err;
	int N;

	do{
		printf("\nBitte geben Sie die untere Intervallgrenze a ein: "); scanf("%lf",&a);
		printf("\nBitte geben Sie die obere Intervallgrenze b ein: "); scanf("%lf",&b);
	}while(a>b || a<0);


	do {
		printf("\nBitte geben Sie die Anzahl der Knoten N ein: "); scanf("%d",&N);
	} while (N<0);


	integral = Rechteck(a, b, N);
	printf("\nDer Wert des Integrals ist %lf.\n", integral);

	if(a < 1)
	{
		if(b > 1)
			int_exakt = fabs(-1-a*log(a)+a)+b*log(b)-b+1;
	}
	else
		int_exakt = fabs(b*log(b)-b-a*log(a)+a);

	err = fabs(int_exakt-integral)/integral*100;

	printf("\nDer prozentuale Fehler ist %.2lf %%\n",err);

	return 0;
}


//Fuktionsdefinition
double Rechteck (double a, double b, int N)
{
	int i;
	double summe = 0.0, h;

	h = (b-a)/N;
	for (i=0; i<N; i++)
		summe += fabs(log(a + i*h));

	return h*summe;
}
